# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ModelProperty(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'str',
        'encrypted': 'bool',
        'read_only': 'bool',
        'format': 'str',
        'minimum': 'int',
        'maximum': 'int',
        'items': 'ModelProperty',
        'min_items': 'int',
        'one_of': 'list[ModelProperty]',
        'max_items': 'int',
        'pattern': 'str',
        'max_length': 'int',
        'min_length': 'int',
        'title': 'str',
        'description': 'str',
        'properties': 'dict(str, ModelProperty)',
        'default': 'object',
        'const': 'object',
        'enum': 'list[object]',
        'dynamic_enum': 'str',
        'dynamic_default': 'str'
    }

    attribute_map = {
        'type': 'type',
        'encrypted': 'encrypted',
        'read_only': 'readOnly',
        'format': 'format',
        'minimum': 'minimum',
        'maximum': 'maximum',
        'items': 'items',
        'min_items': 'minItems',
        'one_of': 'oneOf',
        'max_items': 'maxItems',
        'pattern': 'pattern',
        'max_length': 'maxLength',
        'min_length': 'minLength',
        'title': 'title',
        'description': 'description',
        'properties': 'properties',
        'default': 'default',
        'const': 'const',
        'enum': 'enum',
        'dynamic_enum': '$dynamicEnum',
        'dynamic_default': '$dynamicDefault'
    }

    def __init__(self, type=None, encrypted=None, read_only=None, format=None, minimum=None, maximum=None, items=None, min_items=None, one_of=None, max_items=None, pattern=None, max_length=None, min_length=None, title=None, description=None, properties=None, default=None, const=None, enum=None, dynamic_enum=None, dynamic_default=None):  # noqa: E501
        """ModelProperty - a model defined in Swagger"""  # noqa: E501
        self._type = None
        self._encrypted = None
        self._read_only = None
        self._format = None
        self._minimum = None
        self._maximum = None
        self._items = None
        self._min_items = None
        self._one_of = None
        self._max_items = None
        self._pattern = None
        self._max_length = None
        self._min_length = None
        self._title = None
        self._description = None
        self._properties = None
        self._default = None
        self._const = None
        self._enum = None
        self._dynamic_enum = None
        self._dynamic_default = None
        self.discriminator = None
        if type is not None:
            self.type = type
        if encrypted is not None:
            self.encrypted = encrypted
        if read_only is not None:
            self.read_only = read_only
        if format is not None:
            self.format = format
        if minimum is not None:
            self.minimum = minimum
        if maximum is not None:
            self.maximum = maximum
        if items is not None:
            self.items = items
        if min_items is not None:
            self.min_items = min_items
        if one_of is not None:
            self.one_of = one_of
        if max_items is not None:
            self.max_items = max_items
        if pattern is not None:
            self.pattern = pattern
        if max_length is not None:
            self.max_length = max_length
        if min_length is not None:
            self.min_length = min_length
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if properties is not None:
            self.properties = properties
        if default is not None:
            self.default = default
        if const is not None:
            self.const = const
        if enum is not None:
            self.enum = enum
        if dynamic_enum is not None:
            self.dynamic_enum = dynamic_enum
        if dynamic_default is not None:
            self.dynamic_default = dynamic_default

    @property
    def type(self):
        """Gets the type of this ModelProperty.  # noqa: E501

        Property type should be among valid types (number, integer, string, array, boolean, object)   # noqa: E501

        :return: The type of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ModelProperty.

        Property type should be among valid types (number, integer, string, array, boolean, object)   # noqa: E501

        :param type: The type of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def encrypted(self):
        """Gets the encrypted of this ModelProperty.  # noqa: E501

        Flag indicating if property is encrypted  # noqa: E501

        :return: The encrypted of this ModelProperty.  # noqa: E501
        :rtype: bool
        """
        return self._encrypted

    @encrypted.setter
    def encrypted(self, encrypted):
        """Sets the encrypted of this ModelProperty.

        Flag indicating if property is encrypted  # noqa: E501

        :param encrypted: The encrypted of this ModelProperty.  # noqa: E501
        :type: bool
        """

        self._encrypted = encrypted

    @property
    def read_only(self):
        """Gets the read_only of this ModelProperty.  # noqa: E501

        Flag indicating if property is read only  # noqa: E501

        :return: The read_only of this ModelProperty.  # noqa: E501
        :rtype: bool
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """Sets the read_only of this ModelProperty.

        Flag indicating if property is read only  # noqa: E501

        :param read_only: The read_only of this ModelProperty.  # noqa: E501
        :type: bool
        """

        self._read_only = read_only

    @property
    def format(self):
        """Gets the format of this ModelProperty.  # noqa: E501

        The expected (and pre-defined) format to be used for string validations. Supported format values include: date-time, email, ip-address, alphanumeric, phone, etc.  # noqa: E501

        :return: The format of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._format

    @format.setter
    def format(self, format):
        """Sets the format of this ModelProperty.

        The expected (and pre-defined) format to be used for string validations. Supported format values include: date-time, email, ip-address, alphanumeric, phone, etc.  # noqa: E501

        :param format: The format of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._format = format

    @property
    def minimum(self):
        """Gets the minimum of this ModelProperty.  # noqa: E501

        Minimum value for the property  # noqa: E501

        :return: The minimum of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._minimum

    @minimum.setter
    def minimum(self, minimum):
        """Sets the minimum of this ModelProperty.

        Minimum value for the property  # noqa: E501

        :param minimum: The minimum of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._minimum = minimum

    @property
    def maximum(self):
        """Gets the maximum of this ModelProperty.  # noqa: E501

        Maximum value for the property  # noqa: E501

        :return: The maximum of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._maximum

    @maximum.setter
    def maximum(self, maximum):
        """Sets the maximum of this ModelProperty.

        Maximum value for the property  # noqa: E501

        :param maximum: The maximum of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._maximum = maximum

    @property
    def items(self):
        """Gets the items of this ModelProperty.  # noqa: E501


        :return: The items of this ModelProperty.  # noqa: E501
        :rtype: ModelProperty
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this ModelProperty.


        :param items: The items of this ModelProperty.  # noqa: E501
        :type: ModelProperty
        """

        self._items = items

    @property
    def min_items(self):
        """Gets the min_items of this ModelProperty.  # noqa: E501

        Minimum number of items for the property  # noqa: E501

        :return: The min_items of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._min_items

    @min_items.setter
    def min_items(self, min_items):
        """Sets the min_items of this ModelProperty.

        Minimum number of items for the property  # noqa: E501

        :param min_items: The min_items of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._min_items = min_items

    @property
    def one_of(self):
        """Gets the one_of of this ModelProperty.  # noqa: E501

        Ensures the given data is valid against only one of the specified schemas  # noqa: E501

        :return: The one_of of this ModelProperty.  # noqa: E501
        :rtype: list[ModelProperty]
        """
        return self._one_of

    @one_of.setter
    def one_of(self, one_of):
        """Sets the one_of of this ModelProperty.

        Ensures the given data is valid against only one of the specified schemas  # noqa: E501

        :param one_of: The one_of of this ModelProperty.  # noqa: E501
        :type: list[ModelProperty]
        """

        self._one_of = one_of

    @property
    def max_items(self):
        """Gets the max_items of this ModelProperty.  # noqa: E501

        Maximum number of items for the property  # noqa: E501

        :return: The max_items of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._max_items

    @max_items.setter
    def max_items(self, max_items):
        """Sets the max_items of this ModelProperty.

        Maximum number of items for the property  # noqa: E501

        :param max_items: The max_items of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._max_items = max_items

    @property
    def pattern(self):
        """Gets the pattern of this ModelProperty.  # noqa: E501

        Regular expression to express constraint for the property  # noqa: E501

        :return: The pattern of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """Sets the pattern of this ModelProperty.

        Regular expression to express constraint for the property  # noqa: E501

        :param pattern: The pattern of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._pattern = pattern

    @property
    def max_length(self):
        """Gets the max_length of this ModelProperty.  # noqa: E501

        String instance is validated against this keyword for its maximum length  # noqa: E501

        :return: The max_length of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._max_length

    @max_length.setter
    def max_length(self, max_length):
        """Sets the max_length of this ModelProperty.

        String instance is validated against this keyword for its maximum length  # noqa: E501

        :param max_length: The max_length of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._max_length = max_length

    @property
    def min_length(self):
        """Gets the min_length of this ModelProperty.  # noqa: E501

        String instance is validated against this keyword for its minimum length  # noqa: E501

        :return: The min_length of this ModelProperty.  # noqa: E501
        :rtype: int
        """
        return self._min_length

    @min_length.setter
    def min_length(self, min_length):
        """Sets the min_length of this ModelProperty.

        String instance is validated against this keyword for its minimum length  # noqa: E501

        :param min_length: The min_length of this ModelProperty.  # noqa: E501
        :type: int
        """

        self._min_length = min_length

    @property
    def title(self):
        """Gets the title of this ModelProperty.  # noqa: E501

        Property title  # noqa: E501

        :return: The title of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this ModelProperty.

        Property title  # noqa: E501

        :param title: The title of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this ModelProperty.  # noqa: E501

        Property description  # noqa: E501

        :return: The description of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ModelProperty.

        Property description  # noqa: E501

        :param description: The description of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this ModelProperty.  # noqa: E501

        Properties within the property  # noqa: E501

        :return: The properties of this ModelProperty.  # noqa: E501
        :rtype: dict(str, ModelProperty)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ModelProperty.

        Properties within the property  # noqa: E501

        :param properties: The properties of this ModelProperty.  # noqa: E501
        :type: dict(str, ModelProperty)
        """

        self._properties = properties

    @property
    def default(self):
        """Gets the default of this ModelProperty.  # noqa: E501

        Default value for the property  # noqa: E501

        :return: The default of this ModelProperty.  # noqa: E501
        :rtype: object
        """
        return self._default

    @default.setter
    def default(self, default):
        """Sets the default of this ModelProperty.

        Default value for the property  # noqa: E501

        :param default: The default of this ModelProperty.  # noqa: E501
        :type: object
        """

        self._default = default

    @property
    def const(self):
        """Gets the const of this ModelProperty.  # noqa: E501

        Constant value for the property  # noqa: E501

        :return: The const of this ModelProperty.  # noqa: E501
        :rtype: object
        """
        return self._const

    @const.setter
    def const(self, const):
        """Sets the const of this ModelProperty.

        Constant value for the property  # noqa: E501

        :param const: The const of this ModelProperty.  # noqa: E501
        :type: object
        """

        self._const = const

    @property
    def enum(self):
        """Gets the enum of this ModelProperty.  # noqa: E501

        Restrict a value to a fixed set of values for the property  # noqa: E501

        :return: The enum of this ModelProperty.  # noqa: E501
        :rtype: list[object]
        """
        return self._enum

    @enum.setter
    def enum(self, enum):
        """Sets the enum of this ModelProperty.

        Restrict a value to a fixed set of values for the property  # noqa: E501

        :param enum: The enum of this ModelProperty.  # noqa: E501
        :type: list[object]
        """

        self._enum = enum

    @property
    def dynamic_enum(self):
        """Gets the dynamic_enum of this ModelProperty.  # noqa: E501

        Path that can be used to retrieve permissible values  # noqa: E501

        :return: The dynamic_enum of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_enum

    @dynamic_enum.setter
    def dynamic_enum(self, dynamic_enum):
        """Sets the dynamic_enum of this ModelProperty.

        Path that can be used to retrieve permissible values  # noqa: E501

        :param dynamic_enum: The dynamic_enum of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._dynamic_enum = dynamic_enum

    @property
    def dynamic_default(self):
        """Gets the dynamic_default of this ModelProperty.  # noqa: E501

        Path that can be used to retrieve single permissible default value  # noqa: E501

        :return: The dynamic_default of this ModelProperty.  # noqa: E501
        :rtype: str
        """
        return self._dynamic_default

    @dynamic_default.setter
    def dynamic_default(self, dynamic_default):
        """Sets the dynamic_default of this ModelProperty.

        Path that can be used to retrieve single permissible default value  # noqa: E501

        :param dynamic_default: The dynamic_default of this ModelProperty.  # noqa: E501
        :type: str
        """

        self._dynamic_default = dynamic_default

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ModelProperty, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ModelProperty):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
